import os

import axipy
from PySide2.QtGui import QIcon

from PkkInfo.ui.DlgPkkInfo import DlgPkkFindObject
from PkkInfo.ui.docWidget import AxiDocWidget, addDoc, existDocWidget


class PkkFindLand:
    __name='Поиск объекта на публичной кадастровой карте'
    __name_observer='CountTableGrid'
    __type_observer="catalog"
    __form_tool=None
    __docWidget=None
    __def_name_group="PKK"
    def __init__(self,parentPlugin):
        self._initTool(parentPlugin)
        self.__docWidget=None
    def _initTool(self,parentPlugin):


        local_file_icon=os.path.join(os.path.dirname(os.path.realpath(__file__)),'icon', 'pkk_info_32.png')
        try:
            self.__action=parentPlugin.create_action(self.__name,icon=local_file_icon, on_click=self.__run)
        except Exception as ex:
            jkl=0
        return
    def __run(self):
        if self.__form_tool is None:

            self.__form_tool=DlgPkkFindObject(axipy.app.mainwindow.qt_object())

        if self.__docWidget is None:

            self.__docWidget=AxiDocWidget(self.__form_tool.widget,"PkkFind",self.__name,QIcon(),axipy.app.mainwindow.qt_object())
            addDoc(axipy.app.mainwindow.qt_object(),self.__docWidget)
        else:
            isExist=existDocWidget(axipy.app.mainwindow.qt_object(),self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def initDocWidget(self):
        self.__run()
    def viewReasult(self,pos):
        jjkl=0
    @property
    def name(self):
        return self.__name
    @property
    def name_group(self):
        return self.__def_name_group
    @property
    def action(self):
        return self.__action
    @property
    def nameObserver(self):
        return self.__name_observer
    @property
    def typeObserver(self):
        return self.__type_observer
    @property
    def docWidget(self):
        return self.__docWidget