import urllib

import requests



headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.75 Safari/537.36'}
def clientHttp(url,list_proxy=None):
    error=None
    try:
        if list_proxy is None:
            response=requests.get(url,headers=headers,timeout=3,verify=False)
        else:
            response=requests.get(url,headers=headers,timeout=3,verify=False,proxies=list_proxy)
    except Exception as ex:
        error=ex
        return None,error
    return response,None
class smartHttpClient:
    def __init__(self,callback=None,isProxy=False):
        self.__proxy_cls=None
        self.__proxy=None
        self.__count_replay=7
        self.__delaye_repid=1
        self.__callback=callback
        if isProxy:
            self.__initProxy()
    def __initProxy(self):
        #self.__proxy_cls=ProxyList()
        self.__proxy_cls=None
        self.__proxy_base=self.__proxy_cls.get_https_proxies()
        self.__proxy=[]
        for proxy in self.__proxy_base:
            proxy_url={'https':proxy[0]+':'+proxy[1]}
            resp,err=clientHttp("https://www.google.com/",proxy_url)
            if resp is not None and resp.status_code == requests.codes['ok']:
                self.__proxy.append(proxy_url)
        jkl=0
    def get(self,url):
        response=None
        for i in range(self.__count_replay):
            print("Попытка "+str(i))
            if self.__proxy is not None:
                response,err=clientHttp(url,list_proxy=self.__proxy[0])
            else:
                response,err=clientHttp(url)
            if response is not None:
                break
            if self.__callback is not None:
                self.__callback("Попытка "+str(i))
            import time
            time.sleep(self.__delaye_repid)
        return response
class FindCadastrNumber:
    def __init__(self,list_layer_pkk,base_url,callback=None):
        self.__base_url=base_url
        self.__layers=list_layer_pkk
        self.__client=smartHttpClient(callback)
    def find(self,cad_number):
        for layer in self.__layers:
            url_req=self.__base_url+str(layer)
            #param=urllib.parse.urlencode(cad_number)
            #url_req=url_req+"?"+urllib.parse.urlencode("text="+cad_number)
            url_req=url_req+"?"+"text="+cad_number
            url_req=url_req+"&tolerance=1&limit=40"
            resp=self.__client.get(url_req)
            if resp is not None and resp.status_code == requests.codes['ok']:
                js_obj=resp.json()
                if js_obj['total']==0:
                    continue
                return js_obj
        return None
    def findByCoordinate(self,x,y):
        params_def={}
        params_def['limit']=40
        params_def['skip']=0
        params_def['inPoint']='true'
        params_def['tolerance']=512
        #params_def['text']=str(y)+"+"+str(x)
        url_req=self.__base_url+"?text="+str(y)+"+"+str(x)+"&"+urllib.parse.urlencode(params_def)
        resp=self.__client.get(url_req)
        if resp is not None and resp.status_code == requests.codes['ok']:
            js_obj=resp.json()
            if js_obj['total']>0:
                result_json={}
                result_json['total']=js_obj['total']
                js_feature=[]
                source_results=js_obj['results']
                for item in source_results:
                    try:
                        val_cn=item['attrs']['cn']
                        js_feature.append(item)
                    except:
                        pass
                if len(js_feature)==0:
                    return None
                result_json['features']=js_feature
                return result_json
            else:
                return None
        return None

